#if 0
main() {
#endif

	last( event, timeout );

	if ( isPossibleValidEvent( event ) ) {
		int x, y;
		Prefs prefs;
		UInt16 prefSize;

		x = event->screenX - qtKeyboardLeft;
		y = event->screenY - qtKeyboardTop;

		prefs.autoSpace = false;
		prefs.calX = 0;
		prefs.calY = 0;
		
		PrefGetAppPreferences( creatorId, prfPrefs, &prefs, &prefSize, true );

		x -= prefs.calX;
		y -= prefs.calY;

		switch( event->eType ) {
		case penMoveEvent:
			handlePenMove( x, y, event );
			break;
		case penDownEvent:
			handlePenDown( x, y, event );
			break;
		case penUpEvent:
			handlePenUp( x, y, event, &prefs );
			break;
		}
	}
}


inline void clearPrevInfo() {
	FtrUnregister( creatorId, qtPrevInfo );
	//WinDrawChars( "Clear", 5, 10, 10 );
}


inline Boolean isPossibleValidEvent( EventPtr event ) {
	Boolean validEvent = false;
	Int16 maxLeft = qtKeyboardLeft - qtMaxCalAdjust;
	Int16 maxRight = qtKeyboardLeft + qtKeyboardWidth + qtMaxCalAdjust;
	Int16 maxTop = qtKeyboardTop - qtMaxCalAdjust;


	if( event->eType == penDownEvent ) {
		validEvent = event->screenY >= maxTop
			&& event->screenX >= maxLeft
			&& event->screenX <= maxRight;
	}
	else if( event->eType == penUpEvent
			 || event->eType == penMoveEvent ) {
		validEvent = event->screenY >= maxTop - qtFlickMax
			&& event->screenX >= maxLeft // left row does not flick
			&& event->screenX <= maxRight; // right row does not flick
	}

	return validEvent;
}


// If move too much, flush previous good event
inline void handlePenMove( int x, int y, EventPtr event ) {
	UInt32 prevInfo;
	Byte prevX, prevY;

	// Get the last and make sure it was good.
	if( FtrGet( creatorId, qtPrevInfo, &prevInfo ) != ftrErrNoSuchFeature
		&& getGood( prevInfo ) == true ) {
		prevX = getX( prevInfo );
		prevY = getY( prevInfo );

		// if too far past x or y
		if ( x < prevX - qtFlickMax 
			 || x > prevX + qtFlickMax
			 || y < prevY - qtFlickMax 
			 || y > prevY + qtFlickMax ) {
			clearPrevInfo();
		}
		// good move, need to acknowledge we handled it.
		else {
			event->eType = nilEvent;
		}
	}
	// remove it if it wasn't good
	else {
		clearPrevInfo();
	}
}


inline void handlePenDown( int x, int y, EventPtr event ) {
	UInt32 info;

	// if exactly within keyboard, set as good
	// will be cleared either by move or up
	if( x >= 0 
		&& x <= qtKeyboardWidth 
		&& y >= 0 
		&& y <= qtKeyboardHeight ) {

		setX( info, x ); 
		setY( info, y ); 
		setGood( info, true );
		FtrSet( creatorId, qtPrevInfo, info );
		event->eType = nilEvent;
		//WinDrawChars( "Good", 4, 10, 10 );
	}
}

inline void handlePenUp( int x, int y, EventPtr event, Prefs* prefs ) {
	UInt32 prevInfo;

	if( FtrGet( creatorId, qtPrevInfo, &prevInfo ) != ftrErrNoSuchFeature
		&& getGood( prevInfo ) ) {
		Byte prevX, prevY;
		Boolean quickShift, quickSpace, quickLeft, quickDown;
		int* ichr;

		prevX = getX( prevInfo );
		prevY = getY( prevInfo );

		quickShift = isQuickShift( prevX, prevY, x, y );
		quickSpace = isQuickSpace( prevX, prevY, x, y );
		quickLeft = isQuickLeft( prevX, prevY, x, y );
		quickDown = isQuickDown( prevX, prevY, x, y );

		prevX /= qtBoxWidth;
		prevY /= qtBoxHeight;

		if( prevX != 0 && prevX != 8 ) { // not first or last column
			DmOpenRef gDB;
			UInt16 index = 0;
			
			prevX -= 1;
			index = prevX + ( 7 * prevY );

			if( index < 35 ) { // valid key
				gDB = OpenOrCreateDB();
					
				if ( gDB ) {
					KeyEntry entry;
					VoidHand recordHand = DmQueryRecord( gDB, index );
					VoidPtr recordPtr = MemHandleLock( recordHand );
					
					UnpackKeyEntry( &entry, recordPtr );
					
					if( ! quickLeft && ! quickDown )
						processAlpha( entry.primary, 
									  quickShift, 
									  quickSpace,
									  prefs->autoSpace );
					else if( quickLeft )
						processString( entry.left, 
									   quickShift, 
									   quickSpace,
									   prefs->autoSpace );
					else if( quickDown )
						processString( entry.down, 
									   quickShift, 
									   quickSpace,
									   prefs->autoSpace );
					event->eType = nilEvent;
					
					MemHandleUnlock( recordHand );
					DmCloseDatabase( gDB );
				}
			}
		}
		else { // First or last column
			int nonAlpha;
			if( prevX == 0 ) { // first column
				switch( prevY ) {
				case 0: nonAlpha = qtKeyAlphaPunc; break;
				case 1: nonAlpha = '\t'; break;
				case 2: nonAlpha = qtKeyCapsLock; break;
				case 3: nonAlpha = qtKeyShift; break;
				case 4: nonAlpha = qtKeyAlphaKeyboard; break;
				}
			}
			else { // last column
				switch( prevY ) {
				case 0: nonAlpha = qtKeyNumPunc; break;
				case 1: nonAlpha = '\b'; break;
				case 2: nonAlpha = '\n'; break;
				case 3: nonAlpha = qtKeyShift; break;
				case 4: nonAlpha = qtKeyNumKeyboard; break;
				}
			}
			
			if( nonAlpha > 0 ) {
				processAlpha( nonAlpha, 
							  quickShift, 
							  quickSpace,
							  prefs->autoSpace );
				event->eType = nilEvent;
			}
			else if( processNonAlpha( nonAlpha, event, &prefs ) ) {
				event->eType = nilEvent;
			}
		}
	}
	clearPrevInfo();
}

inline Boolean isQuickShift( Byte prevX, Byte prevY, int x, int y ) {
	int xdiff = prevX - x;
	int ydiff = prevY - y;

	if( ydiff >= qtFlickMin && ydiff <= qtFlickMax ) {
		if( xdiff < 0 )
			xdiff *= -1;

		return xdiff <= ( ( ydiff * 2 ) + 3 );
	}

	return false;
}


inline Boolean isQuickDown( Byte prevX, Byte prevY, int x, int y ) {
	int xdiff = prevX - x;
	int ydiff = y - prevY;

	if( ydiff >= qtFlickMin && ydiff <= qtFlickMax ) {
		if( xdiff < 0 )
			xdiff *= -1;

		return xdiff <= ( ( ydiff * 2 ) + 3 );
	}

	return false;
}

inline Boolean isQuickSpace( Byte prevX, Byte prevY, int x, int y ) {
	int xdiff = x - prevX;
	int ydiff = prevY - y;

	if( xdiff >= qtFlickMin && xdiff <= qtFlickMax ) {
		if( ydiff < 0 )
			ydiff *= -1;

		return ydiff <= ( ( xdiff * 2 ) + 3 );
	}

	return false;
}



inline Boolean isQuickLeft( Byte prevX, Byte prevY, int x, int y ) {
	int xdiff = prevX - x;
	int ydiff = prevY - y;

	if( xdiff >= qtFlickMin && xdiff <= qtFlickMax ) {
		if( ydiff < 0 )
			ydiff *= -1;

		return ydiff <= ( ( xdiff * 2 ) + 3 );
	}

	return false;
}


inline DmOpenRef OpenOrCreateDB() {
	DmOpenRef gDB = NULL;
	gDB = DmOpenDatabaseByTypeCreator('data', 
									  creatorId, 
									  dmModeReadOnly);
	if( ! gDB ) {
		VoidHand imageHandle 
			= DmGetResource('DBIM', databaseImage);
		
		DmCreateDatabaseFromImage(MemHandleLock(imageHandle));
		MemHandleUnlock(imageHandle);
		DmReleaseResource(imageHandle);
		
		gDB = DmOpenDatabaseByTypeCreator('data', 
										  creatorId, 
										  dmModeReadWrite);
	}
	return gDB;
}


inline void processAlpha( WChar ichr, 
						  Boolean quickShift, 
						  Boolean quickSpace,
						  Boolean autoSpace ) {
	Boolean capsLock, numLock;
	Word tempShift;
	Boolean autoShifted;
	UChar uchr = (UChar) ichr;

	GrfGetState( &capsLock, 
				 &numLock, 
				 &tempShift, 
				 &autoShifted );

	if ( quickShift 
		 || capsLock 
		 || tempShift == grfTempShiftUpper ) {
		if ( ( uchr >= 'a' ) && ( uchr <= 'z' ) ) {
			uchr -= 32;
		}
		else if( ( uchr >= 224 ) && ( uchr <= 254 ) ) {
			uchr -= 32;
		}
	}

	if ( quickShift || tempShift ) {
		GrfSetState( capsLock, numLock, false );
	}
	
	EvtEnqueueKey( uchr, 0, 0 );

	if( autoSpace && isPunc( uchr ) )
		EvtEnqueueKey( ' ', 0, 0 );
	if( quickSpace )
		EvtEnqueueKey( ' ', 0, 0 );
}



inline void processString( Char* str,
						   Boolean quickShift, 
						   Boolean quickSpace,
						   Boolean autoSpace ) {
	Int16 strLen = StrLen(str); 
	// Length of the input text. 
	UInt16 i = 0;

	for( i = 0; i < strLen; i++ ) {
		processAlpha( str[ i ],
					  ( i == 0 && quickShift ),
					  ( i == ( strLen - 1 ) && quickSpace ),
					  ( i == ( strLen - 1 ) && autoSpace ) );
	}
}

inline Boolean isPunc( int ichr ) {
	UInt32 prefInfo;
	switch( ichr ) {
	case '!':
	case '?':
	case '.':
	case ',':
	case ':':
	case ';':
		return true;
	default:
		return false;	
	}
}

inline Boolean processNonAlpha( int ichr, EventPtr event, Prefs* prefs ) {
	Boolean capsLock, numLock, handled = false;
	Word tempShift;
	Boolean autoShifted;
	PointType p;

	switch( ichr ) {
	case qtKeyCapsLock:
		GrfGetState( &capsLock, &numLock, &tempShift, &autoShifted );
		capsLock = ! capsLock;
		GrfSetState( capsLock, false, false );
		handled = true;
		break;
	case qtKeyShift:
		GrfGetState( &capsLock, &numLock, &tempShift, &autoShifted );
		tempShift = ! tempShift;
		GrfSetState( false, false, tempShift );
		handled = true;
		break;
	case qtKeyAlphaPunc:
		p.x = hwrGraffitiLeft + qtMaxCalAdjust + 1;
		p.y = hwrGraffitiTop + qtMaxCalAdjust + 1;
		GrfFlushPoints();
		GrfProcessStroke( &p, &p, false );
		handled = true;
		break;
	case qtKeyNumPunc:
		p.x = hwrGraffitiLeft + hwrGraffitiWidth - qtMaxCalAdjust - 1;
		p.y = hwrGraffitiTop + qtMaxCalAdjust + 1;
		GrfFlushPoints();
		GrfProcessStroke( &p, &p, false );
		handled = true;
		break;
	case qtKeyAlphaKeyboard:
		p.x = hwrGraffitiLeft + 10;
		p.y = hwrGraffitiTop + hwrSystemHeight - 10;
		GrfFlushPoints();
		GrfProcessStroke( &p, &p, false );
		handled = true;
		break; 
	case qtKeyNumKeyboard:
		p.x = hwrGraffitiLeft + hwrGraffitiWidth - 10;
		p.y = hwrGraffitiTop + hwrSystemHeight - 10;
		GrfFlushPoints();
		GrfProcessStroke( &p, &p, false );
		handled = true;
		break;
	}

	return handled;
}


// lock record before, and unlock after.  free memory for keyentry.
void UnpackKeyEntry( KeyEntry* entry, const VoidPtr record ) {
	CharPtr s = record;
	UInt16 i = 0;
	UInt16 offset;
	UInt16 len;

	offset = 0;
	entry->primary = *s;
	offset = 1;
	entry->left = s + offset;
	offset += StrLen( entry->left ) + 1;
	entry->down = s + offset;
}
