
/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
package textcounter;

import java.util.*;
import java.io.*;

public class Entry implements Serializable, Comparable {
  private static final ReverseOrderComparator comp = new ReverseOrderComparator();
  Character ch;
  HashMap neighbors = new HashMap();
  int count = 0;

  public Entry( Character ch ) {
    this.ch = ch;
  }

  public void increment() {
    count++;
  }

  public void addNeighbor( Entry e ) {
    Entry neighbor = (Entry) neighbors.get( e.ch );
    if( neighbor == null )
      neighbor = new Entry( e.ch );
    neighbor.increment();
    neighbors.put( e.ch, neighbor );
  }

  public Character getCharacter() {
    return ch;
  }

  public int getCount() {
    return count;
  }

  public HashMap getNeighbors() {
    return neighbors;
  }

  public boolean equals( Object o ) {
    if( o instanceof Entry ) {
      return ch.equals( ( (Entry) o ).ch );
    }
    return false;
  }

  public int compareTo( Object o ) {
    if( ! ( o instanceof Entry ) )
      throw new IllegalArgumentException( "Cannot compare Entry to anything but an Entry" );
    Entry other = (Entry) o;
    if( count == other.count ) {
      return ch.compareTo(other.ch);
    }
    return ( count > other.count ) ? 1 : -1;
  }

  public String toString() {
    StringBuffer buf = new StringBuffer();
    buf.append( ch );
    buf.append( ' ' );

    Set set = new TreeSet(comp);
    set.addAll( neighbors.values() );

    Entry e = null;
    for( Iterator i = set.iterator(); i.hasNext(); ) {
      e = (Entry) i.next();
      buf.append( e.ch );
      if( i.hasNext() )
        buf.append( ' ' );
    }
    return buf.toString();
  }
}